VERSION 5.00
Begin VB.Form frmIntercept 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00000000&
   Caption         =   "Seek Demo"
   ClientHeight    =   5700
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6195
   LinkTopic       =   "Form1"
   ScaleHeight     =   380
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   413
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "frmIntercept"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'**************************************************************
'
' THIS WORK, INCLUDING THE SOURCE CODE, DOCUMENTATION
' AND RELATED MEDIA AND DATA, IS PLACED INTO THE PUBLIC DOMAIN.
'
' THE ORIGINAL AUTHOR IS RYAN CLARK.
'
' THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY
' OF ANY KIND, NOT EVEN THE IMPLIED WARRANTY OF
' MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE,
' ASSUMES _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE
' RESULTING FROM THE USE, MODIFICATION, OR
' REDISTRIBUTION OF THIS SOFTWARE.
'
'**************************************************************
'
' This file was downloaded from The Game Programming Wiki.
' Come and visit us at http://gpwiki.org
'
'**************************************************************

Option Explicit

'The gettickcount API delcaration
Private Declare Function GetTickCount Lib "kernel32" () As Long

Const PI = 3.14159          'Mmmm.. Pi
Const ACCEL = 0.1           'Rate of increase of speed
Const ROTATION_RATE = 15    'Rotation speed
Const SHIP_RADIUS = 10      'Distance from center of triangle to any vertex
Const ENEMY_ACCEL = 0.1     'Rate of enemy's increase of speed
Const ENEMY_RADIUS = 10     'Size of enemy circle
Const MS_DELAY = 25         'Milliseconds per frame (25 = 40 frames per second)

Dim mlngTimer As Long       'Holds system time since last frame was displayed
Dim msngFacing As Single    'Angle the ship is facing (ok, ok, it's a triangle, not a ship! Shut it!)
Dim msngHeading As Single   'Current direction in which ship is moving
Dim msngSpeed As Single     'Current speed with which ship is moving
Dim msngX As Single         'Current X coordinate of ship within form
Dim msngY As Single         'Current Y coordinate of ship within form
Dim msngEnemyFacing As Single    'Angle the enemy is facing
Dim msngEnemyHeading As Single   'Current direction in which enemy is moving
Dim msngEnemySpeed As Single     'Current speed with which enemy is moving
Dim msngEnemyX As Single         'Current X coordinate of enemy within form
Dim msngEnemyY As Single         'Current Y coordinate of enemy within form
Dim mblnRunning As Boolean  'Is the render loop running?
Dim mblnLeftKey As Boolean  'Is the left arrow-key depressed?
Dim mblnRightKey As Boolean 'Is the right arrow-key depressed?
Dim mblnDownKey As Boolean  'Is the down arrow-key depressed?
Dim mblnUpKey As Boolean    'Is the up arrow-key depressed? ... Are YOU depressed? Fly my triangle around for a while, you'll feel better!

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

    'Check for keypresses
    If KeyCode = vbKeyLeft And Not mblnRightKey Then mblnLeftKey = True
    If KeyCode = vbKeyRight And Not mblnLeftKey Then mblnRightKey = True
    If KeyCode = vbKeyUp Then mblnUpKey = True
    If KeyCode = vbKeyDown Then mblnDownKey = True

End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)

    'Check for keyreleases
    If KeyCode = vbKeyLeft Then mblnLeftKey = False
    If KeyCode = vbKeyRight Then mblnRightKey = False
    If KeyCode = vbKeyUp Then mblnUpKey = False
    If KeyCode = vbKeyDown Then mblnDownKey = False

End Sub

Private Sub Form_Load()

    'Initialize the variables
    msngX = 50
    msngY = 50
    msngFacing = 0
    msngSpeed = 0
    msngHeading = 0
    msngEnemyX = 350
    msngEnemyY = 350
    msngEnemyFacing = 0
    msngEnemySpeed = 0
    msngEnemyHeading = 0
    mlngTimer = GetTickCount()
    mblnRunning = True
    
    'Display the form
    DrawShip
    frmIntercept.Show
    
    'Start the render loop
    Do While mblnRunning
        'Check if we've waited for the appropriate number of milliseconds
        If mlngTimer + MS_DELAY <= GetTickCount() Then
            mlngTimer = GetTickCount()  'Reset the timer variable
            Physics                     'Allow the ship's location to be updated
            frmIntercept.Cls                 'Clear the form
            DrawShip                    'Draw the ship
            DrawEnemy                   'Draw the enemy
        End If
        'Allow other events to occur
        DoEvents
    Loop

End Sub

Private Sub Physics()

Dim sngXComp As Single  'Resultant X and Y components
Dim sngYComp As Single
Dim sngMagDiff As Single    'Stores the magnitude of the difference between the enemy and player vectors
Dim sngDirDiff As Single    'Stores the direction of the difference between the enemy and player vectors

    'Rotate right
    If mblnRightKey Then
        msngFacing = msngFacing + ROTATION_RATE * PI / 180
    End If

    'Rotate left
    If mblnLeftKey Then
        msngFacing = msngFacing - ROTATION_RATE * PI / 180
    End If
    
    'Thrust
    If mblnUpKey Then
        AddVectors msngSpeed, msngHeading, ACCEL, msngFacing, msngSpeed, msngHeading
    End If
    
    'Reverse thrust
    If mblnDownKey Then
        AddVectors msngSpeed, msngHeading, ACCEL, msngFacing + PI, msngSpeed, msngHeading
    End If
    
    'Adjust coordinates w.r.t. speed
    msngX = msngX + msngSpeed * Sin(msngHeading)
    msngY = msngY - msngSpeed * Cos(msngHeading)
    
    'Ensure that the ship is visible in the form (wrap edges)
    If msngX > frmIntercept.ScaleWidth Then msngX = 0
    If msngY > frmIntercept.ScaleHeight Then msngY = 0
    If msngX < 0 Then msngX = frmIntercept.ScaleWidth
    If msngY < 0 Then msngY = frmIntercept.ScaleHeight
    
    'Subtract velocity vectors
    AddVectors msngSpeed, msngHeading, msngEnemySpeed, msngEnemyHeading + PI, sngMagDiff, sngDirDiff
    
    'Add approach vector, determine facing
    If sngMagDiff <> 0 Then
        AddVectors ENEMY_ACCEL * GetDist(msngX, msngY, msngEnemyX, msngEnemyY) / sngMagDiff, FindAngle(msngEnemyX, msngEnemyY, msngX, msngY), sngMagDiff, sngDirDiff, , msngEnemyFacing
    Else
        msngEnemyFacing = FindAngle(msngEnemyX, msngEnemyY, msngX, msngY)
    End If
    
    'Enemy thrust
    AddVectors msngEnemySpeed, msngEnemyHeading, ENEMY_ACCEL, msngEnemyFacing, msngEnemySpeed, msngEnemyHeading
    
    'Adjust enemy coordinates w.r.t. speed
    msngEnemyX = msngEnemyX + msngEnemySpeed * Sin(msngEnemyHeading)
    msngEnemyY = msngEnemyY - msngEnemySpeed * Cos(msngEnemyHeading)
    
    'Wrap enemy at edges of form
    If msngEnemyX > frmIntercept.ScaleWidth Then msngEnemyX = 0
    If msngEnemyY > frmIntercept.ScaleHeight Then msngEnemyY = 0
    If msngEnemyX < 0 Then msngEnemyX = frmIntercept.ScaleWidth
    If msngEnemyY < 0 Then msngEnemyY = frmIntercept.ScaleHeight

End Sub

Private Sub DrawShip()

Dim intX1 As Integer    'Coordinates of the 3 triangle verticies
Dim intY1 As Integer
Dim intX2 As Integer
Dim intY2 As Integer
Dim intX3 As Integer
Dim intY3 As Integer

    'Calculate the new ship vertices
    intX1 = msngX + SHIP_RADIUS * Sin(msngFacing)
    intY1 = msngY - SHIP_RADIUS * Cos(msngFacing)
    intX2 = msngX + SHIP_RADIUS * Sin(msngFacing + 2 * PI / 3)
    intY2 = msngY - SHIP_RADIUS * Cos(msngFacing + 2 * PI / 3)
    intX3 = msngX + SHIP_RADIUS * Sin(msngFacing + 4 * PI / 3)
    intY3 = msngY - SHIP_RADIUS * Cos(msngFacing + 4 * PI / 3)
    
    'Draw the ship's lines
    Line (intX1, intY1)-(intX2, intY2), vbRed
    Line (intX2, intY2)-(intX3, intY3), vbWhite
    Line (intX3, intY3)-(intX1, intY1), vbRed

End Sub

Private Sub DrawEnemy()

    'Draw the enemy circle
    Circle (msngEnemyX, msngEnemyY), ENEMY_RADIUS, vbWhite

End Sub

Private Sub AddVectors(sngMag1 As Single, sngDir1 As Single, sngMag2 As Single, sngDir2 As Single, Optional ByRef sngMagResult As Single, Optional ByRef sngDirResult As Single)

Dim sngXComp As Single
Dim sngYComp As Single
     
    'Determine the components of the resultant vector
    sngXComp = sngMag1 * Sin(sngDir1) + sngMag2 * Sin(sngDir2)
    sngYComp = sngMag1 * Cos(sngDir1) + sngMag2 * Cos(sngDir2)
    'Determine the resultant magnitude
    sngMagResult = Sqr(sngXComp ^ 2 + sngYComp ^ 2)
    'Calculate the resultant direction, and adjust for arctangent by adding Pi if necessary
    If sngYComp > 0 Then sngDirResult = Atn(sngXComp / sngYComp)
    If sngYComp < 0 Then sngDirResult = Atn(sngXComp / sngYComp) + PI

End Sub

Private Function FixAngle(ByVal sngAngle As Single) As Single

Dim blnFixed As Boolean 'Has the angle been fixed?

    'Loop until the angle is between 0 and 2Pi
    blnFixed = False
    Do While Not (blnFixed)
        If sngAngle > 2 * PI Then
            sngAngle = sngAngle - (2 * PI)
        ElseIf sngAngle < 0 Then
            sngAngle = sngAngle + (2 * PI)
        Else
            blnFixed = True
        End If
    Loop
    
    'Return the value
    FixAngle = sngAngle

End Function

Private Function FindAngle(intX1 As Single, intY1 As Single, intX2 As Single, intY2 As Single) As Single

Dim sngXComp As Single
Dim sngYComp As Single

    'Find the angle between the 2 coords
    sngXComp = intX2 - intX1
    sngYComp = intY1 - intY2
    If Sgn(sngYComp) > 0 Then FindAngle = Atn(sngXComp / sngYComp)
    If Sgn(sngYComp) < 0 Then FindAngle = Atn(sngXComp / sngYComp) + PI

End Function

Private Function GetDist(intX1 As Single, intY1 As Single, intX2 As Single, intY2 As Single) As Single

    'Return the distance between the two points (I love you, Mr. Pythagoras)
    GetDist = Sqr((intX1 - intX2) ^ 2 + (intY1 - intY2) ^ 2)

End Function

Private Sub Form_Unload(Cancel As Integer)

    'Terminate the render loop
    mblnRunning = False

End Sub
